<?php

namespace app\abutment\controller;

use app\BaseController;
use think\facade\Db;

//销售订单(对应于采销端的采购单)
class Order extends BaseController
{

    //列表
    public function getList()
    {
        $this->post = $this->request->filter('trim')->post();

        $page = isset($this->post['page']) && $this->post['page'] !== "" ? intval($this->post['page']) : "1";
        $size = isset($this->post['size']) && $this->post['size'] !== "" ? intval($this->post['size']) : "10";
        $where = [['po.is_del', "=", 0], ['po.supplierNo', '=', $this->request->user['supplierNo']]];
        $bkcode = isset($this->post['bk_code']) && $this->post['bk_code'] != "" ? trim($this->post['bk_code']) : "";
        if ($bkcode != "") {
            $where[] = ['po.bkcode', "like", "%{$bkcode}%"];
        }
        $status = isset($this->post['status']) && $this->post['status'] !== "" ? intval($this->post['status']) : "";
        if ($status !== "") {
            // $where['status'] = $status;
            $where[] = ['po.status', "=", $status];
        }
        $cgdNo = isset($this->post['cgdNo']) && $this->post['cgdNo'] != "" ? trim($this->post['cgdNo']) : "";
        if ($cgdNo != "") {
            //$where['cgdNo'] = Db::Raw("like '%{$cgdNo}%'");
            $where[] = ['po.cgdNo', "like", "%{$cgdNo}%"];
        }

        $apply_name = isset($this->post['apply_name']) && $this->post['apply_name'] != "" ? trim($this->post['apply_name']) : "";
        if ($apply_name != "") {
            // $where['cgder'] =Db::Raw("like '%{$apply_name}%'");
            $where[] = ['po.cgder', "like", "%{$apply_name}%"];
        }
        $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code'] != "" ? trim($this->post['wsm_code']) : "";
        if ($wsm_code != "") {
            // $where['wsm_code'] = $wsm_code;
            $where[] = ['po.wsm_code', "=", $wsm_code];
        }
        $wsm_in_code = isset($this->post['wsm_in_code']) && $this->post['wsm_in_code'] != "" ? trim($this->post['wsm_in_code']) : "";
        if ($wsm_in_code != "") {
            $incode = Db::name("purchease_in")->where(["wsm_in_code" => Db::raw(" like %{$wsm_in_code}%"), "is_del" => 0])->column("cgdNo");
            if (empty($incode)) {
                return json_show(1005, "未找到有关入库单信息");
            }
            $where[] = ['po.cgdNo', "in", $incode];
        }
        $good_name = isset($this->post['good_name']) && $this->post['good_name'] != "" ? trim($this->post['good_name']) : "";
        if ($good_name != "") {
            //$where['good_name'] = Db::raw(" like %{$good_name}%");
            $where[] = ['po.good_name', "like", "%{$good_name}%"];
        }
        $good_code = isset($this->post['good_code']) && $this->post['good_code'] != "" ? trim($this->post['good_code']) : "";
        if ($good_code != "") {
            // $where['good_code'] = Db::raw(" like %{$good_code}%");
            $where[] = ['po.spuCode', "like", "%{$good_code}%"];
        }
        $supplierNo = isset($this->post['supplierNo']) && $this->post['supplierNo'] != "" ? trim($this->post['supplierNo']) : "";
        if ($supplierNo != "") {
            // $where['good_code'] = Db::raw(" like %{$good_code}%");
            $where[] = ['po.supplierNo', "like", "%{$supplierNo}%"];
        }
        $wsm_supplierNo = isset($this->post['wsm_supplierNo']) && $this->post['wsm_supplierNo'] != "" ? trim($this->post['wsm_supplierNo']) : "";
        if ($wsm_supplierNo != "") {
            $supplier = Db::name("supplier")->where(["code" => $wsm_supplierNo])->find();
            if (empty($supplier)) {
                return json_show(1004, "未找到供应商信息");
            }
            $wsmcode = Db::name("warehouse_info")->where(["is_del" => 0, "supplierNo" => $wsm_supplierNo])->column("wsm_code");
            $where[] = ['po.wsm_code', "in", $wsmcode];
        }
        $start = isset($this->post['start']) && $this->post['start'] != "" ? $this->post['start'] : "";
        if ($start != "") {
            // $where['addtime'] = Db::raw(" >= '{$start}'");
            $where[] = ['po.addtime', ">=", $start];
        }
        $end = isset($this->post['end']) && $this->post['end'] != "" ? $this->post['end'] : "";
        if ($end != "") {
            $where[] = ['po.addtime', "<=", $end];
        }
        $last_start = isset($this->post['last_start']) && $this->post['last_start'] != "" ? $this->post['last_start'] : "";
        if ($last_start != "") {
            //$where['lasttime'] = Db::raw(" >= '{$last_start}'");
            $where[] = ['po.lasttime', ">=", $last_start];

        }
        $last_end = isset($this->post['last_end']) && $this->post['last_end'] != "" ? $this->post['last_end'] : "";
        if ($last_end != "") {
            //$where['lasttime'] = Db::raw(" <= '{$last_end}'");
            $where[] = ['po.lasttime', "<=", $last_end];
        }
        $orderCode = isset($this->post['orderCode']) && $this->post['orderCode'] != "" ? $this->post['orderCode'] : "";
        if ($orderCode != "") {
            //$where['lasttime'] = Db::raw(" <= '{$last_end}'");
            $where[] = ['on.orderCode', "like", '%' . $orderCode . '%'];
        }

        $company_name = isset($this->post['company_name']) && $this->post['company_name'] !== "" ? trim($this->post['company_name']) : "";
        if ($company_name !== "") $where[] = ["po.cgder_id", 'in', get_company_item_user_by_name($company_name)];

//        if(!empty($role['platform']) ){
//            $where[]=["po.platform_id","in",$role['platform']];
//        }
        $count = Db::name("purchease_order")->alias('po')->leftJoin('order_num on', 'on.cgdNo=po.cgdNo')->where($where)
            ->where(function ($query) use ($where) {
                $query->whereOr([['po.order_type', '<>', 1], ['po.order_source', '=', 0]]);
            })->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name("purchease_order")
            ->alias('po')
            ->leftJoin('order_num on', 'on.cgdNo=po.cgdNo')
            ->leftJoin("depart_user u", "u.uid=po.cgder_id AND u.is_del=0")
            ->field('po.*,on.orderCode,u.itemid')
            ->where($where)
            ->where(function ($query) use ($where) {
                $query->whereOr([['po.order_type', '<>', 1], ['po.order_source', '=', 0]]);
            })
            ->page($page, $size)
            ->order("po.addtime desc")
            ->cursor();
        $data = [];
        foreach ($list as $value) {
            $value['wsm_name'] = "";
            if ($value['wsm_code'] != "") {
                $wsmcode = Db::name("warehouse_info")->alias("a")->leftJoin("supplier b", "a.supplierNo=b.code")
                    ->where(["a.wsm_code" => $value['wsm_code']])->field("a.name as wsm_name,b.name,b.code")->find();
                $value['wsm_name'] = isset($wsmcode['wsm_name']) ? $wsmcode['wsm_name'] : "";
                $value['wsm_supplier'] = isset($wsmcode['name']) ? $wsmcode['name'] : "";
                $value['wsm_supplierNo'] = isset($wsmcode['code']) ? $wsmcode['code'] : "";
            }
            if ($value['order_type'] == 3) {
                $goon = Db::name("good_zixun")->where(["spuCode" => $value['spuCode'], "is_del" => 0])->find();
                $value["speclist"] = isset($goon['specinfo']) && $goon['specinfo'] != "" ? json_decode($goon['specinfo'], true) : "";
            } else {
                $goon = Db::name('good_basic')->where(['spuCode' => $value['spuCode']])->find();
                $spec = Db::name("good_spec")->where(["spuCode" => $goon['spuCode'], "is_del" => 0])->select()->toArray();
                $speclist = [];
                if (!empty($spec)) {
                    foreach ($spec as $val) {
                        $temp = [];
                        $temp['id'] = $val['id'];
                        $temp['spuCode'] = $val['spuCode'];
                        $temp['spec_id'] = $val['spec_id'];
                        $temp['spec_value_id'] = $val['spec_value_id'];
                        $sp = Db::name("specs")->where(["id" => $val['spec_id']])->find();
                        $temp['spec_name'] = isset($sp["spec_name"]) ? $sp["spec_name"] : "";
                        $spv = Db::name("spec_value")->where(["id" => $val['spec_value_id']])->find();
                        $temp['spec_value'] = isset($spv["spec_value"]) ? $spv["spec_value"] : "";
                        $speclist[] = $temp;
                    }
                }
                $value["speclist"] = empty($speclist) ? [] : $speclist;
            }

            //采购单详情字段order_type 为1或者2时，取线上商品库 商品创建人   order_type 为3或者4时 取采购反馈的商品库 商品反馈人
//            $value['cgder_id'] = $goon['createrid'];
//            $value['cgder'] = $goon['creater'];

            $inorder = Db::name("purchease_in")->where(['cgdNo' => $value['cgdNo'], "is_del" => 0])->select();
            $value['child'] = empty($inorder) ? [] : $inorder;
            $value['send_num'] -= $value['th_num'];
            $value['total_fee'] = round($value['total_fee'] - $value['th_fee'], 2);
            //补充orderCode
//            $value['orderCode']=isset($all_orderCodes[$value['cgdNo']])?$all_orderCodes[$value['cgdNo']]:'';
            $value['company_name'] = implode('/', array_column(GetPart($value['itemid']), 'name'));
            $data[] = $value;
        }
        return json_show(0, "获取成功", ["list" => $data, "count" => $count]);
    }

    //详情
    public function info()
    {
        $this->post = $this->request->filter('trim')->post();

        $cgdNo = isset($this->post['cgdNo']) && $this->post['cgdNo'] != "" ? trim($this->post['cgdNo']) : "";
        if ($cgdNo == "") {
            return json_show(1004, "参数cgdNo 不能为空");
        }
        //采购单
        $data = Db::name("purchease_order")->where(["cgdNo" => $cgdNo, "is_del" => 0, 'supplierNo' => $this->request->user['supplierNo']])->find();
        if (empty($data)) {
            return json_show(1004, "未找到数据");
        }
        //采购退货单
        $im = Db::name('purchease_back')->where(['cgdNo' => $data['cgdNo'], 'is_del' => 0])->select();
        $var = [];
        foreach ($im as $value) {
            if ($data['order_type'] == 3) {
                $goo = Db::name("good_zixun")->where(["spuCode" => $value['spuCode'], "is_del" => 0])->find();
            } else {
                $goo = Db::name('good_basic')->where(['spuCode' => $value['spuCode']])->find();
            }
            if ($goo == false) {
                return json_show(1005, "未找到商品数据");
            }
            $cat = isset($goo['cat_id']) && $goo['cat_id'] != 0 ? made($goo['cat_id']) : [];
            $value['cant'] = $cat;
            $var[] = $value;
        }
        //采购工差单
        $dom = Db::name("purchease_diff")->where(['cgdNo' => $data['cgdNo'], 'is_del' => 0])->find();
        if ($data['order_type'] == 3) {
            $goon = Db::name("good_zixun")->where(["spuCode" => $data['spuCode'], "is_del" => 0])->find();
        } else {
            $goon = Db::name('good_basic')->where(['spuCode' => $data['spuCode']])->find();
        }
        if (empty($goon)) {
            return json_show(1005, "未找到商品数据");
        } else {
            $goon['exclusive'] = isset($goon['is_exclusive']) ? makeExcluse($goon['is_exclusive']) : "";
            $unit = Db::name("unit")->where(["id" => $goon['good_unit']])->find();
            $goon['unit'] = isset($unit['unit']) ? $unit['unit'] : '';
            $spec = Db::name("good_spec")->where(["spuCode" => $goon['spuCode'], "is_del" => 0])->select()->toArray();
            $speclist = [];
            if (!empty($spec)) {
                foreach ($spec as $value) {
                    $temp = [];
                    $temp['id'] = $value['id'];
                    $temp['spuCode'] = $value['spuCode'];
                    $temp['spec_id'] = $value['spec_id'];
                    $temp['spec_value_id'] = $value['spec_value_id'];
                    $temp['is_del'] = $value['is_del'];
                    $sp = Db::name("specs")->where(["id" => $value['spec_id']])->find();
                    $temp['spec_name'] = isset($sp["spec_name"]) ? $sp["spec_name"] : "";
                    $spv = Db::name("spec_value")->where(["id" => $value['spec_value_id']])->find();
                    $temp['spec_value'] = isset($spv["spec_value"]) ? $spv["spec_value"] : "";
                    $speclist[] = $temp;
                }
            }
            $goon["speclist"] = empty($speclist) ? [] : $speclist;
            $proof = Db::name("good_proof")->where(["spuCode" => $goon['spuCode'], "is_del" => 0])->order("updatetime desc")->field("id,proof_type,proof_url")->find();
            $goon['proof'] = isset($proof) && $proof != false ? $proof : [];
            $goon['origin_place_cn'] = "";
            $goon['delivery_place_cn'] = "";
            if (isset($goon['delivery_place']) && $goon['delivery_place'] !== "") {
                $place = ["provice_code" => "", "city_code" => "", "area_code" => ""];
                list($place['provice_code'], $place['city_code'], $place['area_code']) = explode(",", $goon['delivery_place']);
                $goon['delivery_place_cn'] = GetAddr(json_encode($place));
            }
            if (isset($goon['delivery_place']) && $goon['origin_place'] !== "") {
                $place = ["provice_code" => "", "city_code" => "", "area_code" => ""];
                list($place['provice_code'], $place['city_code'], $place['area_code']) = explode(",", $goon['origin_place']);
                $goon['origin_place_cn'] = GetAddr(json_encode($place));
            }
            if ($goon['brand_id'] != 0) {
                $brand = Db::name("brand")->where(["id" => $goon['brand_id']])->find();
                $goon["brand_name"] = isset($brand['brand_name']) ? $brand['brand_name'] : "";
            } else {
                $goon["brand_name"] = "";
                $goon["brand_id"] = "";
            }

            $supplier = Db::name("supplier")->where(["code" => $goon['supplierNo']])->find();
            $goon['supplierName'] = isset($supplier['name']) ? $supplier['name'] : "";
            $goon['noble_name'] = isset($goon['noble_metal']) && $goon['noble_metal'] != 0 ? $this->noble[$goon['noble_metal']] : "";
            if (isset($goon['companyNo']) && $goon['companyNo'] != "") {
                $company = Db::name("business")->where(["companyNo" => $goon['companyNo']])->find();
            }
            $goon['company'] = isset($company['company']) ? $company['company'] : "";
        }
        $int = isset($goon['cat_id']) && $goon['cat_id'] != 0 ? made($goon['cat_id']) : [];
        $data['wsm_name'] = "";
        if ($data['wsm_code'] != "") {
            $wsmcode = Db::name("warehouse_info")->alias("a")->leftJoin("supplier b", "a.supplierNo=b.code")
                ->leftJoin("warehouse_addr c", "a.wsm_code=c.wsm_code and c.is_del=0")
                ->where(["a.wsm_code" => $data['wsm_code']])->field("a.name as wsm_name,b.name,b.code,c.wsm_name as wsm_contactor,c.wsm_mobile,c.wsm_addr,c.addr_code")->find();
            $data['wsm_name'] = isset($wsmcode['wsm_name']) ? $wsmcode['wsm_name'] : "";
            $data['wsm_supplier'] = isset($wsmcode['name']) ? $wsmcode['name'] : "";
            $data['wsm_supplierNo'] = isset($wsmcode['code']) ? $wsmcode['code'] : "";
            $data['wsm_contactor'] = isset($wsmcode['wsm_contactor']) ? $wsmcode['wsm_contactor'] : "";
            $data['wsm_mobile'] = isset($wsmcode['wsm_mobile']) ? $wsmcode['wsm_mobile'] : "";
            // $data['wsm_addr'] =isset($wsmcode['wsm_addr']) ? $wsmcode['wsm_addr']:"";
            $data['addr_code'] = isset($wsmcode['addr_code']) ? $wsmcode['addr_code'] : "";
            $data['wsm_addr'] = isset($wsmcode['addr_code']) ? GetAddr($wsmcode['addr_code']) : "";
            $data['wsm_addr'] .= isset($wsmcode['wsm_addr']) ? $wsmcode['wsm_addr'] : "";
            $inorder = Db::name("purchease_in")->where(['cgdNo' => $data['cgdNo'], "is_del" => 0])->select();
            $data['child'] = empty($inorder) ? [] : $inorder;
        }

        $data['can'] = $int;
        $data['goodinfo'] = $goon;
        $data['purcheasediff'] = $dom;
        $data['send_num'] -= $data['th_num'];
        $data['total_fee'] = round($data['total_fee'] - $data['th_fee'], 2);
        if (isset($data['companyNo']) && $data['companyNo'] != "") {
            $company = Db::name("business")->where(["companyNo" => $data['companyNo']])->find();
        }
        $data['company'] = isset($company['company']) ? $company['company'] : "";
        //$data['info'] = $var;
        $data['purcheaseback'] = $var;

        //补充orderCode
        $data['orderCode'] = Db::name('order_num')
            ->where('cgdNo', $data['cgdNo'])
            ->value('orderCode', '');

        //补充收货地址
        $addr = Db::name('order_addr')
            ->field('id,addr,addr_code,contactor,mobile,receipt_quantity')
            ->where(['orderCode' => $data['orderCode'], 'is_del' => 0])
            ->select()
            ->toArray();
        if (!empty($addr)) {
            foreach ($addr as &$vv) {
                $temp = explode(',', $vv['addr_code']);
                $temp_ = GetAddr(json_encode(['provice_code' => isset($temp[0]) ? $temp[0] : '', 'city_code' => isset($temp[1]) ? $temp[1] : '', 'area_code' => isset($temp[2]) ? $temp[2] : '']));
                $vv['addr_code'] = $temp_ . $vv['addr'];
            }
        } else $addr = [];
        $data['addr_info'] = $addr;

        //补充客户名称
        if (empty($data['orderCode'])) $data['customer'] = [];
        else {
            $data['customer'] = Db::name('sale')
                ->alias('s')
                ->field('c.companyNo,c.companyName')
                ->leftJoin('customer_info c', 'c.companyNo=s.customer_code AND c.is_del=0')
                ->where(['s.orderCode' => $data['orderCode']])
                ->find();
        }

        return json_show(0, "获取成功", $data);
    }


}